#include <def2191.h>
#include "def2191bit.h"
#include <sysreg.h>
#include <signal.h>

#define BUFSIZE 16

struct TDMADescriptor 
{
	int configuration, startPage, startAddress, count;
	struct TDMADescriptor * nextDescriptor;
};

int rxBuffer[BUFSIZE];
struct TDMADescriptor  terminationTCB, rxTCB;

void sportRxHandler( int sig );
void setupSport( void );
void setupTCB( void );

int main(void)
{
	interrupt( SIG_INT5, sportRxHandler );		// SIG_INT5 is default interupt for SPORT0 RX
    enable_interrupts();                 // O[o荞݃Cl[u
	setupTCB();									// TCB Configuratoin
	setupSport();								// SPORT0 RX Configuration
	while ( 1 )
		;
}

void setupSport( void )
{

	sysreg_write( sysreg_IOPG, SPORT0_Controller_Page );
	io_space_write( SP0DR_CFG, 0 );		// RX DMA Disable
	io_space_write( SP0_RCR, 0 );		// RX disable
	io_space_write( SP0_TCR, 0 );		// TX disable

	io_space_write( SP0_RFSDIV, 255 );	// 256 bit per frame
	io_space_write( SP0_MRCS0, 0xffff );
	io_space_write( SP0_MRCS1, 0 );	
	io_space_write( SP0_MRCS2, 0 );	
	io_space_write( SP0_MRCS3, 0 );	
	io_space_write( SP0_MRCS4, 0 );	
	io_space_write( SP0_MRCS5, 0 );	
	io_space_write( SP0_MRCS6, 0 );	
	io_space_write( SP0_MRCS7, 0 );	

	io_space_write( SP0_MCMC1, 0 << WOFF_OFST | 1 << WSIZE_OFST | 1 << MFD_OFST | MCM );
	io_space_write( SP0_MCMC2, MCDRXPE );

	io_space_write( SP0DR_CP, (int) &rxTCB );	// set chain pointer
	io_space_write( SP0DR_CPR, 1 );		// ready descriptor pointer
	io_space_write( SP0DR_CFG, DEN );
	io_space_write( SP0_RCR,  IRFS | SLEN_16 | RSPEN );
}

void setupTCB( void )
{
			// setting up the DMA TCB
	rxTCB.configuration = DOWN | DCOME | TRAN | DEN;
	rxTCB.startPage = 0;
	rxTCB.startAddress = (int)rxBuffer;
	rxTCB.count = BUFSIZE;
	rxTCB.nextDescriptor = &terminationTCB;
			// setting up the DMA TCB for termination
	terminationTCB.configuration = 0;
	terminationTCB.startPage = 0;
	terminationTCB.startAddress = 0;
	terminationTCB.count = 0;
	terminationTCB.nextDescriptor = ( struct TDMADescriptor * )0;
}

void sportRxHandler( int sig )
{
	sysreg_write( sysreg_IOPG, SPORT0_Controller_Page );
	io_space_write( SP0DR_IRQ, 1 );		// clear interrupt from SP0 RX
}


